library(gnlm)
library(repeated)

data <- read.table("animal.dat",skip=5)
train <- gl(2,8,16)
stimulus <- gl(2,4,16)
trial <- trial2 <- y <- list()
yy <- traint <- stimt <- times <- NULL
for(i in 1:ncol(data)){
	traint <-c(traint,rep(train[i]==1,10+length(data[11:20,i][data[11:20,i]>0])))
	stimt <-c(stimt,rep(stimulus[i]==1,10+length(data[11:20,i][data[11:20,i]>0])))
	trial <- c(trial,list(matrix(1:(10+length(data[11:20,i][data[11:20,i]>0])),ncol=1)))
	trial2 <- c(trial2,list(cbind(as.double(1:(10+length(data[11:20,i][data[11:20,i]>0]))),as.double(1:(10+length(data[11:20,i][data[11:20,i]>0])))^2)))
	times <- c(times,1:(10+length(data[11:20,i][data[11:20,i]>0])))
	y <- c(y,list(cbind(c(data[1:10,i],data[11:20,i][data[11:20,i]>0]),
		1:(10+length(data[11:20,i][data[11:20,i]>0])))))
	yy <- c(yy,data[1:10,i],data[11:20,i][data[11:20,i]>0])}
yb <- restovec(y,total=20)
y <- restovec(y)

if(interactive()){
postscript("animal0.eps")
par(mfrow=c(2,2),font.main=1)
plot(y[[1]][,2],y[[1]][,1],xlim=c(0,20),ylim=c(0,25),
	xlab="",ylab="Successes",main="Not trained - Bell")
lines(y[[1]][,2],y[[1]][,1],lty=3)
for(i in 2:4){
	points(y[[i]][,2],y[[i]][,1],pch=i+20)
	lines(y[[i]][,2],y[[i]][,1],lty=3)}
plot(y[[5]][,2],y[[5]][,1],xlim=c(0,20),ylim=c(0,25),
	xlab="",ylab="",main="Not trained - Light")
lines(y[[5]][,2],y[[5]][,1],lty=3)
for(i in 2:4){
	points(y[[i+4]][,2],y[[i+4]][,1],pch=i+20)
	lines(y[[i+4]][,2],y[[i+4]][,1],lty=3)}
plot(y[[9]][,2],y[[9]][,1],xlim=c(0,20),ylim=c(0,25),
	xlab="Trial",ylab="Successes",main="Pre-trained - Bell")
for(i in 2:4){
	points(y[[i+8]][,2],y[[i+8]][,1],pch=i+20)
	lines(y[[i+8]][,2],y[[i+8]][,1],lty=3)}
lines(y[[9]][,2],y[[9]][,1],lty=3)
plot(y[[13]][,2],y[[13]][,1],xlim=c(0,20),ylim=c(0,25),
	xlab="Trial",ylab="",main="Pre-trained - Light")
lines(y[[13]][,2],y[[13]][,1],lty=3)
for(i in 2:4){
	points(y[[i+12]][,2],y[[i+12]][,1],pch=i+20)
	lines(y[[i+12]][,2],y[[i+12]][,1],lty=3)}
}

mu <- function(p) p[1]*rep(1,210)
mu1 <- function(p) p[1]+p[2]*times
mu2 <- function(p) exp(p[1]+p[2]*times)
mu3 <- function(p) exp(p[1]+p[2]*times+p[3]*stimt)
mu4 <- function(p) exp(p[1]+p[2]*times+p[3]*traint)
mu5 <- function(p) exp(p[1]+p[2]*times+p[3]*stimt+p[4]*times*stimt)
mu3l <- function(p) {
	tmp <- exp(p[1]+p[2]*times+p[3]*stimt)
	20*tmp/(1+tmp)}
mu3ll <- function(p) 20*exp(-exp(p[1]+p[2]*times+p[3]*stimt))
mu3cll <- function(p) 20*(1-exp(-exp(p[1]+p[2]*times+p[3]*stimt)))
mu4l <- function(p) {
	tmp <- exp(p[1]+p[2]*times+p[3]*stimt)
	p[4]*tmp/(1+tmp)}
mu4ll <- function(p) p[4]*exp(-exp(p[1]+p[2]*times+p[3]*stimt))
mu4cll <- function(p) p[4]*(1-exp(-exp(p[1]+p[2]*times+p[3]*stimt)))
mu3li <- function(p) {
	tmp <- exp(p[1]+p[2]*times+p[3]*stimt+p[4]*times*stimt)
	20*tmp/(1+tmp)}
mu3clli <- function(p) 20*(1-exp(-exp(p[1]+p[2]*times+p[3]*stimt+p[4]*times*stimt)))

gnlr(yy,"Poisson",mu=mu3l,pmu=c(-3.8,0.6,0.4))
gnlr(yy,"Poisson",mu=mu3cll,pmu=c(-3.8,0.6,0.4))
gnlr(yy,"negative binomial",mu=mu3l,pmu=c(-3.8,0.6,0.4),psh=1.7)
gnlr(yy,"negative binomial",mu=mu3cll,pmu=c(-3.8,0.6,0.4),psh=1.7)
gnlr(yy,"mult Poisson",mu=mu3l,pmu=c(-3.9,0.6,0.5),psh=-0.1)
gnlr(yy,"mult Poisson",mu=mu3cll,pmu=c(-3.9,0.6,0.5),psh=-0.1)
gnlr(yy,"double Poisson",mu=mu3l,pmu=c(-3.9,0.6,0.5),psh=-1)
gnlr(yy,"double Poisson",mu=mu3cll,pmu=c(-3.9,0.6,0.5),psh=-1)

gnlr(yy,"Poisson",mu=mu3li,pmu=c(-3.8,0.6,0.4,0))
gnlr(yy,"Poisson",mu=mu3clli,pmu=c(-3.8,0.6,0.4,0))
gnlr(yy,"negative binomial",mu=mu3li,pmu=c(-3.8,0.6,0.4,0),psh=1.7)
gnlr(yy,"negative binomial",mu=mu3clli,pmu=c(-3.8,0.6,0.4,0),psh=1.7)
gnlr(yy,"mult Poisson",mu=mu3li,pmu=c(-3.9,0.6,0.5,0),psh=-0.1)
gnlr(yy,"mult Poisson",mu=mu3clli,pmu=c(-3.9,0.6,0.5,0),psh=-0.1)
gnlr(yy,"double Poisson",mu=mu3li,pmu=c(-3.9,0.6,0.5,0),psh=-1)
gnlr(yy,"double Poisson",mu=mu3clli,pmu=c(-3.9,0.6,0.5,0),psh=-1)

gnlr(yy,"Poisson",mu=mu4l,pmu=c(-3.8,0.6,0.4,20))
gnlr(yy,"Poisson",mu=mu4cll,pmu=c(-3.8,0.6,0.4,20))
gnlr(yy,"negative binomial",mu=mu4l,pmu=c(-3.8,0.6,0.4,20),psh=1.7)
gnlr(yy,"negative binomial",mu=mu4cll,pmu=c(-3.8,0.6,0.4,20),psh=1.7)
gnlr(yy,"mult Poisson",mu=mu4l,pmu=c(-3.9,0.6,0.4,22),psh=0)
gnlr(yy,"mult Poisson",mu=mu4cll,pmu=c(-3.9,0.6,0.5,20),psh=-0.1)
gnlr(yy,"double Poisson",mu=mu4l,pmu=c(-3.9,0.6,0.5,22),psh=-1)
gnlr(yy,"double Poisson",mu=mu4cll,pmu=c(-3.9,0.6,0.5,20),psh=-1)

gar(y,dist="Poisson",mu=mu2,preg=c(0,0.03),pdep=0.1)
gar(y,dist="Poisson",mu=mu3,preg=c(0.15,0.2,0.8),pdep=0.9)
gar(y,dist="Poisson",mu=mu3l,preg=c(0,0.03,0),pdep=0.1)
gar(y,dist="Poisson",mu=mu3cll,preg=c(0,0.03,0),pdep=0.1)
gar(y,dist="negative",mu=mu2,preg=c(0,0.03),psh=1.5,pdep=0.1)
gar(y,dist="negative",mu=mu4,preg=c(0,0.03,0),psh=1.5,pdep=0.1)
gar(y,dist="negative",mu=mu3,preg=c(0.15,0.2,0.8),psh=0.7,pdep=0.9)
print(znbl <- gar(y,dist="negative",mu=mu3l,preg=c(0.15,0.2,0.8),
	psh=0.7,pdep=0.9))
if(interactive()){
mul <- function(p,tt,st) {
	tmp <- exp(p[1]+p[2]*tt+p[3]*st)
	20*tmp/(1+tmp)}
#postscript("animal1.eps")
par(mfrow=c(2,2),font.main=1)
plot(iprofile(znbl),nind=1:2,lty=c(3,2),pch=c(21,22),xlim=c(0,20),ylim=c(0,25),
	xlab="",ylab="Successes",main="Not trained - Bell")
lines(1:20,mul(znbl$coef,1:20,1))
plot(iprofile(znbl),nind=5:6,lty=c(3,2),pch=c(21,22),xlim=c(0,20),ylim=c(0,25),
	xlab="",ylab="Successes",main="Not trained - Light")
lines(1:20,mul(znbl$coef,1:20,0))
plot(iprofile(znbl),nind=9:10,lty=c(3,2),pch=c(21,22),xlim=c(0,20),
	ylim=c(0,25),xlab="",ylab="Successes",main="Pre-trained - Bell")
lines(1:20,mul(znbl$coef,1:20,1))
plot(iprofile(znbl),nind=13:14,lty=c(3,2),pch=c(21,22),xlim=c(0,20),
	ylim=c(0,25),xlab="",ylab="Successes",main="Pre-trained - Light")
lines(1:20,mul(znbl$coef,1:20,0))
}

gar(y,dist="negative",mu=mu3ll,preg=c(0.15,0.2,0.8),psh=0.7,pdep=0.9)
print(znbcll <- gar(y,dist="negative",mu=mu3cll,preg=c(0.15,0.2,0.8),
	psh=0.7,pdep=0.9))
if(interactive()){
mucll <- function(p,tt,st) 20*(1-exp(-exp(p[1]+p[2]*tt+p[3]*st)))
#postscript("animal1.eps")
par(mfrow=c(2,2),font.main=1)
plot(iprofile(znbcll),nind=1:2,lty=c(3,2),pch=c(21,22),xlim=c(0,20),
	ylim=c(0,25),xlab="",ylab="Successes",main="Not trained - Bell")
lines(1:20,mucll(znbcll$coef,1:20,1))
plot(iprofile(znbcll),nind=5:6,lty=c(3,2),pch=c(21,22),xlim=c(0,20),
	ylim=c(0,25),xlab="",ylab="Successes",main="Not trained - Light")
lines(1:20,mucll(znbcll$coef,1:20,0))
plot(iprofile(znbcll),nind=9:10,lty=c(3,2),pch=c(21,22),xlim=c(0,20),
	ylim=c(0,25),xlab="",ylab="Successes",main="Pre-trained - Bell")
lines(1:20,mucll(znbcll$coef,1:20,1))
plot(iprofile(znbcll),nind=13:14,lty=c(3,2),pch=c(21,22),xlim=c(0,20),
	ylim=c(0,25),xlab="",ylab="Successes",main="Pre-trained - Light")
lines(1:20,mucll(znbcll$coef,1:20,0))
}

gar(y,dist="mult Poisson",mu=mu3l,preg=c(0.15,0.2,0.8),psh=0.7,pdep=0.9)
gar(y,dist="mult Poisson",mu=mu3cll,preg=c(0.15,0.2,0.8),psh=0.7,pdep=0.9)
gar(y,dist="double Poisson",mu=mu3l,preg=c(0.15,0.2,0.8),psh=0.7,pdep=0.9)
gar(y,dist="double Poisson",mu=mu3cll,preg=c(0.15,0.2,0.8),psh=0.7,pdep=0.9)

gar(y,dist="Poisson",mu=mu3li,preg=c(-3.8,0.6,0.4,0),pdep=0.1)
gar(y,dist="Poisson",mu=mu3clli,preg=c(0,0.03,0,0),pdep=0.1)
gar(y,dist="negative",mu=mu3li,preg=c(-3.5,0.44,0.4,0.4),psh=0.7,pdep=0.1)
gar(y,dist="negative",mu=mu3clli,preg=c(0.15,0.2,0.8,0),psh=0.7,pdep=0.9)
gar(y,dist="mult Poisson",mu=mu3li,preg=c(0.15,0.2,0.8,0),psh=0.7,pdep=0.9)
gar(y,dist="mult Poisson",mu=mu3clli,preg=c(0.15,0.2,0.8,0),psh=0.7,pdep=0.9)
print(zdpl <- gar(y,dist="double Poisson",mu=mu3li,preg=c(0.15,0.2,0.8,0),
	psh=0.7,pdep=0.9))
gar(y,dist="double Poisson",mu=mu3clli,preg=c(-3.3,0.4,0.5,0),psh=0.7,pdep=0.9)

if(interactive()){
mucll <- function(p,tt,st) 20*(1-exp(-exp(p[1]+p[2]*tt+p[3]*st)))
postscript("animal1.eps")
par(mfrow=c(2,2),font.main=1)
plot(iprofile(zdpl),nind=1:2,lty=c(3,2),pch=c(21,22),xlim=c(0,20),ylim=c(0,25),
	xlab="",ylab="Successes",main="Not trained - Bell")
lines(1:20,mucll(zdpl$coef,1:20,1))
plot(iprofile(zdpl),nind=5:6,lty=c(3,2),pch=c(21,22),xlim=c(0,20),ylim=c(0,25),
	xlab="",ylab="Successes",main="Not trained - Light")
lines(1:20,mucll(zdpl$coef,1:20,0))
plot(iprofile(zdpl),nind=9:10,lty=c(3,2),pch=c(21,22),xlim=c(0,20),
	ylim=c(0,25),xlab="",ylab="Successes",main="Pre-trained - Bell")
lines(1:20,mucll(zdpl$coef,1:20,1))
plot(iprofile(zdpl),nind=13:14,lty=c(3,2),pch=c(21,22),xlim=c(0,20),
	ylim=c(0,25),xlab="",ylab="Successes",main="Pre-trained - Light")
lines(1:20,mucll(zdpl$coef,1:20,0))
}

gar(y,dist="Poisson",mu=mu4l,preg=c(0,0.03,0,20),pdep=0.1)
gar(y,dist="Poisson",mu=mu4cll,preg=c(0,0.03,0,20),pdep=0.1)
gar(y,dist="negative",mu=mu4l,preg=c(0,0.03,0,20),psh=0.7,pdep=0.9)
gar(y,dist="negative",mu=mu4cll,preg=c(0.15,0.2,0.8,20),psh=0.7,pdep=0.9)
gar(y,dist="mult Poisson",mu=mu4l,preg=c(0.15,0.2,0.8,20),psh=0.7,pdep=0.9)
gar(y,dist="mult Poisson",mu=mu4cll,preg=c(0.15,0.2,0.8,20),psh=0.7,pdep=0.9)
gar(y,dist="double Poisson",mu=mu4l,preg=c(0.15,0.2,0.8,20),psh=0.7,pdep=0.9)
gar(y,dist="double Poisson",mu=mu4cll,preg=c(0.15,0.2,0.8,20),psh=0.7,pdep=0.9)

nbkal(y,mu=mu1,preg=c(1,0.04),pdep=0.1)

kalcount(y,int="Weibull",mu=mu1,ptvc=c(0,0.04),psh=2)
kalcount(y,int="Weibull",mu=mu2,ptvc=c(0,0.04),psh=2)
kalcount(y,int="Weibull",tvcov=trial,preg=1,ptvc=0.04,psh=2)
kalcount(y,ccov=~stimulus,preg=c(0,0),pdep=0.5,dep="frailty")
kalcount(y,int="Weibull",ccov=~stimulus,preg=c(0,0),psh=2,dep="frailty")
kalcount(y,int="Weibull",mu=mu1,ptvc=c(0,0.04),pdep=0.5,psh=2,dep="serial")
kalcount(y,int="Weibull",mu=mu2,ptvc=c(1,0.04),pdep=0.5,psh=2,dep="serial")
kalcount(y,int="Weibull",ccov=~train,tvcov=trial,preg=c(0,0),ptvc=0.04,
	pdep=0.5,psh=2,dep="serial")
kalcount(y,int="Weibull",ccov=~stimulus,tvcov=trial,preg=c(0,0),ptvc=0.04,
	pdep=0.5,psh=2,dep="serial")
kalcount(y,int="Weibull",ccov=~stimulus,tvcov=trial2,preg=c(-0.2,0.3),
	ptvc=c(0,-0.1),pinit=0.6,pdep=0.5,psh=2,dep="serial")

kalcount(y,ccov=~stimulus,preg=c(0,0),pdep=0.5,dep="serial")
print(zw <- kalcount(y,int="Weibull",ccov=~stimulus,preg=c(0,0),
	pdep=0.5,psh=2,dep="serial"))
if(interactive()){
muzl <- function(p,tt,st) exp(p[5])*exp(p[1]+p[2]*st)*
	(tt/exp(p[1]+p[2]*st))^(exp(p[5])-1)
postscript("animal2.eps")
par(mfrow=c(2,2),font.main=1)
plot(iprofile(zw),nind=1:2,lty=c(3,2),pch=c(21,22),xlim=c(0,20),ylim=c(0,25),
	xlab="",ylab="Successes",main="Not trained - Bell")
lines(1:20,muzl(zw$coef,1:20,0))
plot(iprofile(zw),nind=5:6,lty=c(3,2),pch=c(21,22),xlim=c(0,20),ylim=c(0,25),
	xlab="",ylab="Successes",main="Not trained - Light")
lines(1:20,muzl(zw$coef,1:20,1))
plot(iprofile(zw),nind=9:10,lty=c(3,2),pch=c(21,22),xlim=c(0,20),ylim=c(0,25),
	xlab="",ylab="Successes",main="Pre-trained - Bell")
lines(1:20,muzl(zw$coef,1:20,0))
plot(iprofile(zw),nind=13:14,lty=c(3,2),pch=c(21,22),xlim=c(0,20),ylim=c(0,25),
	xlab="",ylab="Successes",main="Pre-trained - Light")
lines(1:20,muzl(zw$coef,1:20,1))
}
kalcount(y,int="Weibull",ccov=~stimulus,preg=c(0,0),
	pdep=0.5,psh=2,dep="serial",upd="kalman")

print(zgl <- kalcount(y,int="gen log",ccov=~stimulus,preg=c(1,-0.6),
	pdep=0.5,psh=0.05,dep="serial",pinter=0))
ft <- function (tt) 
	exp(-tt/0.05033)/(0.05033 + 1.12961 * exp(-1.0363 * tt))^(1 + 
		1/(0.05033 * 1.0363)) * (0.05033 + 1.12961)^(1/(0.05033 * 
		1.0363))
if(interactive()){
muzgl <- function(p,tt,st) 1/(exp(p[5])+exp(-(p[1]+p[2]*st)*tt+p[6]))
postscript("animal3.eps")
par(mfrow=c(2,2),font.main=1)
plot(iprofile(zgl),nind=1:2,lty=c(3,2),pch=c(21,22),xlim=c(0,20),ylim=c(0,25),
	xlab="",ylab="Successes",main="Not trained - Bell")
#plot(mprofile(zgl),nind=1,add=T)
lines(1:20,muzgl(zgl$coef,1:20,0))
plot(iprofile(zgl),nind=5:6,lty=c(3,2),pch=c(21,22),xlim=c(0,20),ylim=c(0,25),
	xlab="",ylab="Successes",main="Not trained - Light")
lines(1:20,muzgl(zgl$coef,1:20,1))
plot(iprofile(zgl),nind=9:10,lty=c(3,2),pch=c(21,22),xlim=c(0,20),ylim=c(0,25),
	xlab="",ylab="Successes",main="Pre-trained - Bell")
lines(1:20,muzgl(zgl$coef,1:20,0))
plot(iprofile(zgl),nind=13:14,lty=c(3,2),pch=c(21,22),xlim=c(0,20),ylim=c(0,25),
	xlab="",ylab="Successes",main="Pre-trained - Light")
lines(1:20,muzgl(zgl$coef,1:20,1))
}

kalcount(y,mu=mu3l,ptvc=c(-2.7,0.02,-0.03),pinit=0.6,pdep=0.5,dep="serial")
print(zwl <- kalcount(y,int="Weibull",mu=mu3l,ptvc=c(-2.7,0.02,-0.03),
	pinit=0.6,pdep=0.5,psh=2,dep="serial"))
if(interactive()){
muzll <- function(p,tt,st) exp(p[5])*exp(p[1]+p[2]*st+p[3]*tt)*
	(tt/exp(p[1]+p[2]*st+p[3]*tt))^(exp(p[6])-1)
par(mfrow=c(2,2),font.main=1)
plot(iprofile(zwl),nind=1:2,lty=c(3,2),pch=c(21,22),xlim=c(0,20),ylim=c(0,25),
	xlab="",ylab="Successes",main="Not trained - Bell")
lines(1:20,muzll(zwl$coef,1:20,0))
plot(iprofile(zwl),nind=5:6,lty=c(3,2),pch=c(21,22),xlim=c(0,20),ylim=c(0,25),
	xlab="",ylab="Successes",main="Not trained - Light")
lines(1:20,muzll(zwl$coef,1:20,1))
plot(iprofile(zwl),nind=9:10,lty=c(3,2),pch=c(21,22),xlim=c(0,20),ylim=c(0,25),
	xlab="",ylab="Successes",main="Pre-trained - Bell")
lines(1:20,muzll(zwl$coef,1:20,0))
plot(iprofile(zwl),nind=13:14,lty=c(3,2),pch=c(21,22),xlim=c(0,20),
	ylim=c(0,25),xlab="",ylab="Successes",main="Pre-trained - Light")
lines(1:20,muzll(zwl$coef,1:20,1))
}
kalcount(y,int="Weibull",mu=mu3cll,ptvc=c(-2.7,0.02,-0.03),
	pinit=0.6,pdep=0.5,psh=2,dep="serial")

kalcount(y,int="gamma",ccov=~stimulus,preg=c(0,0),
	pdep=0.5,psh=2,dep="serial")
kalcount(y,int="log normal",ccov=~stimulus,preg=c(0.1,0.45),
	pinit=11,pdep=0.3,psh=0.1,dep="serial")
kalcount(y,int="log Cauchy",ccov=~stimulus,preg=c(0.1,0.5),
	pinit=1,pdep=0.3,psh=0.1,dep="serial")

kalcount(y,ccov=~stimulus,preg=c(0,0),pdep=0.98,dep="serial",density=T)
kalcount(y,int="Weibull",ccov=~stimulus,preg=c(3.3,0.07),
	pdep=0.3,psh=1,dep="serial",density=T)
kalcount(y,int="Weibull",mu=mu3l,ptvc=c(3.3,0.02,-0.03),
	pinit=1,pdep=0.3,psh=1,dep="serial",density=T)

mu <- function(p) p[1]*rep(1,210)
mu1 <- function(p) p[1]+p[2]*times
mu1a <- function(p) p[1]+p[2]*times+p[3]*stimt
mu1ai <- function(p) p[1]+p[2]*times+p[3]*stimt+p[4]*stimt*times
mul <- function(p){
    tmp <- exp(p[1])*rep(1,210)
    tmp/(1+tmp)}
mu1l <- function(p){
    tmp <- exp(p[1]+p[2]*times)
    tmp/(1+tmp)}
mu1al <- function(p){
    tmp <- exp(p[1]+p[2]*times+p[3]*stimt)
    tmp/(1+tmp)}
mu1ll <- function(p) exp(-exp(p[1]+p[2]*times+p[3]*stimt))
mu1ali <- function(p){
    tmp <- exp(p[1]+p[2]*times+p[3]*stimt+p[4]*stimt*times)
    tmp/(1+tmp)}
mu1lli <- function(p) exp(-exp(p[1]+p[2]*times+p[3]*stimt+p[4]*stimt*times))

gnlr(cbind(yy,20-yy),dist="binomial",mu=mul,pmu=c(-4))
gnlr(cbind(yy,20-yy),dist="binomial",mu=mu1l,pmu=c(-3.6,0.46))
gnlr(cbind(yy,20-yy),dist="binomial",mu=mu1al,pmu=c(-3.6,0.46,1.83))
gnlr(cbind(yy,20-yy),dist="beta binomial",mu=mu1al,pmu=c(-3.6,0.46,1.83),psh=1)
gnlr(cbind(yy,20-yy),dist="mult binomial",mu=mu1al,pmu=c(-3.6,0.46,1.83),psh=1)
gnlr(cbind(yy,20-yy),dist="double binomial",mu=mu1al,pmu=c(-0.8,0.1,0.4),
	psh=-2)

gnlr(cbind(yy,20-yy),dist="binomial",mu=mu1ali,pmu=c(-3.6,0.46,1.83,0))
gnlr(cbind(yy,20-yy),dist="beta binomial",mu=mu1ali,pmu=c(-3.6,0.46,1.83,0),
	psh=1)
gnlr(cbind(yy,20-yy),dist="mult binomial",mu=mu1ali,pmu=c(-3.6,0.46,1.83,0),
	psh=1)
gnlr(cbind(yy,20-yy),dist="double binomial",mu=mu1ali,pmu=c(-0.8,0.1,0.4,0),
	psh=-2)

gnlr(cbind(yy,20-yy),dist="binomial",mu=mu1ll,pmu=c(1.9,-0.3,-1.1))
gnlr(cbind(yy,20-yy),dist="beta binomial",mu=mu1ll,pmu=c(1.9,-0.3,-1.1),psh=1)
gnlr(cbind(yy,20-yy),dist="mult binomial",mu=mu1ll,pmu=c(1.9,-0.3,-1.1),psh=1)
gnlr(cbind(yy,20-yy),dist="double binomial",mu=mu1ll,pmu=c(1.9,-0.3,-1.1),
	psh=1)

gnlr(cbind(yy,20-yy),dist="binomial",mu=mu1lli,pmu=c(1.9,-0.3,-1.1,0))
gnlr(cbind(yy,20-yy),dist="beta binomial",mu=mu1lli,pmu=c(1.9,-0.3,-1.1,0),
	psh=1)
gnlr(cbind(yy,20-yy),dist="mult binomial",mu=mu1lli,pmu=c(1.9,-0.3,-1.1,0),
	psh=1)
gnlr(cbind(yy,20-yy),dist="double binomial",mu=mu1lli,pmu=c(1.9,-0.3,-1.1,0),
	psh=1)

gar(yb,dist="binomial",mu=mu,preg=c(-2),pdep=0.1,link="logit")
gar(yb,dist="binomial",mu=mu1,preg=c(-2,0.3),pdep=0.1,link="logit")
gar(yb,dist="binomial",mu=mu1a,preg=c(-2,0.3,0), pdep=0.1,link="logit")
gar(yb,dist="beta binomial",mu=mu1a,preg=c(-2,0.3,0),
	 psh=1,pdep=0.5,link="logit")
gar(yb,dist="mult binomial",mu=mu1a,preg=c(-2,0.3,0),
	 psh=1,pdep=0.1,link="logit")
print(zdb2 <- gar(yb,dist="double binomial",mu=mu1a,preg=c(-4,0.6,2),
	 psh=0.3,pdep=0.03,link="logit"))

gar(yb,dist="binomial",mu=mu1ai,preg=c(-2,0.3,0,0),pdep=0.1,link="logit")
gar(yb,dist="beta binomial",mu=mu1ai,preg=c(-2,0.3,0,0),
	 psh=1,pdep=0.5,link="logit")
gar(yb,dist="mult binomial",mu=mu1ai,preg=c(-2,0.3,0,0),
	 psh=1,pdep=0.1,link="logit")
gar(yb,dist="double binomial",mu=mu1ai,preg=c(-2,0.3,0,0),
	 psh=0.1,pdep=0.1,link="logit")

gar(yb,dist="binomial",mu=mu1a,preg=c(-2,0.3,0), pdep=0.1,link="cloglog")
gar(yb,dist="beta binomial",mu=mu1a,preg=c(-2,0.3,0),
	psh=1,pdep=0.5,link="cloglog")
gar(yb,dist="mult binomial",mu=mu1a,preg=c(-2,0.3,0),
	psh=1,pdep=0.1,link="cloglog")
gar(yb,dist="double binomial",mu=mu1a,preg=c(-2,0.3,0),
	psh=0.1,pdep=0.1,link="cloglog")

gar(yb,dist="binomial",mu=mu1ai,preg=c(1.6,-0.3,0,0),pdep=0.1,
	link="cloglog")
gar(yb,dist="beta binomial",mu=mu1ai,preg=c(-2,0.3,0,0),
	psh=1,pdep=0.5,link="cloglog")
gar(yb,dist="mult binomial",mu=mu1ai,preg=c(2,-0.4,-0.1,0),
	psh=1,pdep=0.1,link="cloglog")
gar(yb,dist="double binomial",mu=mu1ai,preg=c(2,-0.4,-0.1,0),
	psh=0.1,pdep=0.1,link="cloglog")

if(interactive()){
mu1ap <- function(p,times,stimt) exp(p[1]+p[2]*times+p[3]*stimt)/
      (1+exp(p[1]+p[2]*times+p[3]*stimt))*20
postscript("animal1b.eps")
par(mfrow=c(2,2),font.main=1)
plot(iprofile(zdb2),nind=1:2,lty=c(3,2),pch=c(21,22),xlim=c(0,20),ylim=c(0,25),
	xlab="",ylab="Successes",main="Not trained - Bell")
lines(1:20,mu1ap(zdb2$coef,1:20,1))
plot(iprofile(zdb2),nind=5:6,lty=c(3,2),pch=c(21,22),xlim=c(0,20),ylim=c(0,25),
	xlab="",ylab="",main="Not trained - Light")
lines(1:20,mu1ap(zdb2$coef,1:20,0))
plot(iprofile(zdb2),nind=9:10,lty=c(3,2),pch=c(21,22),xlim=c(0,20),
	ylim=c(0,25),xlab="",ylab="Successes",main="Pre-trained - Bell")
lines(1:20,mu1ap(zdb2$coef,1:20,1))
plot(iprofile(zdb2),nind=13:14,lty=c(3,2),pch=c(21,22),xlim=c(0,20),
	ylim=c(0,25),xlab="",ylab="",main="Pre-trained - Light")
lines(1:20,mu1ap(zdb2$coef,1:20,0))
}

print(zl <- gnlr(yy,"Poisson",mu=mu3l,pmu=c(-3.8,0.6,0.4)))
#gnlmm(yy,"Poisson",mu=mu3l,pmu=zl$coef,psd=1,nest=gl(210,1,210),points=3)
gnlmm(yy,"Poisson",mu=mu3l,pmu=c(-4.51,0.63,2.36),psd=0.87,
	nest=gl(210,1,210),points=3)
gnlmm(yy,"Poisson",mu=mu3li,pmu=c(-4.51,0.63,2.36,0),psd=0.87,
	nest=gl(210,1,210),points=3)
print(zcll <- gnlr(yy,"Poisson",mu=mu3cll,pmu=c(-3.8,0.4,1.5)))
#gnlmm(yy,"Poisson",mu=mu3cll,pmu=zcll$coef,psd=1,nest=gl(210,1,210),points=3)
gnlmm(yy,"Poisson",mu=mu3cll,pmu=c(-4.01,0.49,1.96),psd=0.85,
	nest=gl(210,1,210),points=3)
gnlmm(yy,"Poisson",mu=mu3clli,pmu=c(-4.01,0.49,1.96,0),psd=0.85,
	nest=gl(210,1,210),points=3)

gnlmm(cbind(yy,20-yy),dist="binomial",mu=mu1al,pmu=c(-3.6,0.46,1.83),psd=1.2,
	nest=gl(210,1,210),points=3)
gnlmm(cbind(yy,20-yy),dist="binomial",mu=mu1ali,pmu=c(-3.6,0.46,1.83,0),
	psd=1.2,nest=gl(210,1,210),points=3)
gnlmm(cbind(yy,20-yy),dist="binomial",mu=mu1ll,pmu=c(1.9,-0.3,-1.1),psd=1.2,
	nest=gl(210,1,210),points=3)
gnlmm(cbind(yy,20-yy),dist="binomial",mu=mu1lli,pmu=c(1.9,-0.3,-1.1,0),psd=1.2,
	nest=gl(210,1,210),points=3)
