library(repeated)
library(gnlm)

deaths <- scan("deaths.dat",skip=3)
y <- restovec(matrix(deaths,ncol=72,byrow=T))
sex <- c(0,1)
seasc <- rep(cos(pi*rep(1:12,6)/6),2)
seass <- rep(sin(pi*rep(1:12,6)/6),2)
seasc2 <- rep(cos(pi*rep(1:12,6)/3),2)
seass2 <- rep(sin(pi*rep(1:12,6)/3),2)
seasc3 <- rep(cos(2*pi*rep(1:12,6)/3),2)
seass3 <- rep(sin(2*pi*rep(1:12,6)/3),2)
tvct <- rbind(as.double(1:72),as.double(1:12))
tvc1 <- list(cbind(cos(pi*rep(1:12,6)/6),sin(pi*rep(1:12,6)/6)),
	cbind(cos(pi*rep(1:12,6)/6),sin(pi*rep(1:12,6)/6)))
for(i in 1:2)colnames(tvc1[[i]]) <- c("cos6","sin6")
tvc2 <- list(cbind(cos(pi*rep(1:12,6)/6),sin(pi*rep(1:12,6)/6),
	cos(pi*rep(1:12,6)/3),sin(pi*rep(1:12,6)/3)),
	cbind(cos(pi*rep(1:12,6)/6),sin(pi*rep(1:12,6)/6),
	cos(pi*rep(1:12,6)/3),sin(pi*rep(1:12,6)/3)))
for(i in 1:2)colnames(tvc2[[i]]) <- c("cos6","sin6","cos3","sin3")
tvc2t <- list(cbind(cos(pi*rep(1:12,6)/6),sin(pi*rep(1:12,6)/6),
	cos(pi*rep(1:12,6)/3),sin(pi*rep(1:12,6)/3),as.double(1:72)),
	cbind(cos(pi*rep(1:12,6)/6),sin(pi*rep(1:12,6)/6),
	cos(pi*rep(1:12,6)/3),sin(pi*rep(1:12,6)/3),as.double(1:72)))
for(i in 1:2)colnames(tvc2t[[i]]) <- c("cos6","sin6","cos3","sin3","trend")
tvc3 <- list(cbind(cos(pi*rep(1:12,6)/6),sin(pi*rep(1:12,6)/6),
	cos(pi*rep(1:12,6)/3),sin(pi*rep(1:12,6)/3),
	cos(2*pi*rep(1:12,6)/3),sin(2*pi*rep(1:12,6)/3)),
	cbind(cos(pi*rep(1:12,6)/6),sin(pi*rep(1:12,6)/6),
	cos(pi*rep(1:12,6)/3),sin(pi*rep(1:12,6)/3),
	cos(2*pi*rep(1:12,6)/3),sin(2*pi*rep(1:12,6)/3)))
for(i in 1:2)colnames(tvc3[[i]]) <- c("cos6","sin6","cos3","sin3",
	"cos1.5","sin1.5")
tvc3t <- list(cbind(cos(pi*rep(1:12,6)/6),sin(pi*rep(1:12,6)/6),
	cos(pi*rep(1:12,6)/3),sin(pi*rep(1:12,6)/3),
	cos(2*pi*rep(1:12,6)/3),sin(2*pi*rep(1:12,6)/3),as.double(1:72)),
	cbind(cos(pi*rep(1:12,6)/6),sin(pi*rep(1:12,6)/6),
	cos(pi*rep(1:12,6)/3),sin(pi*rep(1:12,6)/3),
	cos(2*pi*rep(1:12,6)/3),sin(2*pi*rep(1:12,6)/3),as.double(1:72)))
for(i in 1:2)colnames(tvc3t[[i]]) <- c("cos6","sin6","cos3","sin3",
	"cos1.5","sin1.5","trend")
tvc3ti <- list(cbind(cos(pi*rep(1:12,6)/6),sin(pi*rep(1:12,6)/6),
	cos(pi*rep(1:12,6)/3),sin(pi*rep(1:12,6)/3),
	cos(2*pi*rep(1:12,6)/3),sin(2*pi*rep(1:12,6)/3),as.double(1:72),
	as.double(1:72)*sin(pi*rep(1:12,6)/3)),
	cbind(cos(pi*rep(1:12,6)/6),sin(pi*rep(1:12,6)/6),
	cos(pi*rep(1:12,6)/3),sin(pi*rep(1:12,6)/3),
	cos(2*pi*rep(1:12,6)/3),sin(2*pi*rep(1:12,6)/3),as.double(1:72),
	as.double(1:72)*sin(pi*rep(1:12,6)/3)))
for(i in 1:2)colnames(tvc3ti[[i]]) <- c("cos6","sin6","cos3","sin3",
	"cos1.5","sin1.5","trend","trend.sin3")
tvc2is <- list(cbind(cos(pi*rep(1:12,6)/6),sin(pi*rep(1:12,6)/6),
	cos(pi*rep(1:12,6)/3),sin(pi*rep(1:12,6)/3),rep(0,72),rep(0,72)),
	cbind(cos(pi*rep(1:12,6)/6),sin(pi*rep(1:12,6)/6),
	cos(pi*rep(1:12,6)/3),sin(pi*rep(1:12,6)/3),
	cos(pi*rep(1:12,6)/6),sin(pi*rep(1:12,6)/6)))
for(i in 1:2)colnames(tvc2is[[i]]) <- c("cos6","sin6","cos3","sin3",
	"sex.cos6","sex.sin6")

sum(deaths-deaths*log(deaths)+lgamma(deaths+1))+144
print(z0 <- glm(deaths~1,family=poisson))
z0$aic/2
print(z1 <- update(z0,.~.+gl(2,72,144)))
z1$aic/2
print(z2 <- update(z1,.~.+seasc+seass))
z2$aic/2
print(z3 <- update(z2,.~.+seasc2+seass2))
z3$aic/2
print(z4 <- update(z3,.~.+seasc3+seass3))
z4$aic/2
print(z5 <- update(z4,.~.+rep(1:72,2)))
z5$aic/2

mu <- function(p,linear) exp(linear)
sexf <- gl(2,72,144)
gnlr(deaths,"Poisson",mu=mu,linear=~1,pmu=7.3)
gnlr(deaths,"negative bin",mu=mu,linear=~1,pmu=7.3,psh=-1)
gnlr(deaths,"negative bin",mu=mu,linear=~sexf,pmu=c(7.3,-1),psh=-1)
gnlr(deaths,"negative bin",mu=mu,linear=~sexf+seass+seasc,
	pmu=c(7.3,-1,0.2,0.3),psh=-1)
gnlr(deaths,"negative bin",mu=mu,linear=~sexf+seass+seasc
	+seass2+seasc2,pmu=c(7.3,-1,0.3,0.2,0,0),psh=-1)
gnlr(deaths,"negative bin",mu=mu,linear=~sexf+seass+seasc
	+seass2+seasc2+seass3+seasc3,pmu=c(7.3,-1,0.3,0.2,0.06,0,0,0),psh=-1)
gnlr(deaths,"negative bin",mu=mu,linear=~sexf+seass+seasc+rep(1:12,12),
	pmu=c(7.3,-1,0.2,0.3,-0.001),psh=-1)
gnlr(deaths,"negative bin",mu=mu,linear=~sexf+seass+seasc
	+seass2+seasc2+seass3+seasc3+rep(1:72,2),
	pmu=c(7.3,-1,0.3,0.2,0.06,0,0,0,0),psh=-1)

kalcount(y,preg=-7)
kalcount(y,preg=-c(7,-1.1),ccov=sex,pinit=0.1)
kalcount(y,preg=-c(7.3,-1),ccov=sex,pinit=0.01,tvc=tvc1,ptvc=-c(0.2,0.3))
kalcount(y,preg=-c(7.3,-1),ccov=sex,pinit=0.01,tvc=tvc2,
	ptvc=-c(0.2,0.3,0.006,0.05))
kalcount(y,preg=-c(7.3,-1),ccov=sex,pinit=0.01,tvc=tvc2t,
	ptvc=-c(0.2,0.3,0.006,0.05,0))
kalcount(y,preg=-c(7.3,-1),ccov=sex,pinit=0.01,tvc=tvc3,
	ptvc=-c(0.2,0.3,0.006,0.05,0,0))
kalcount(y,preg=-c(7.36,-1),ccov=sex,pinit=0.01,tvc=tvc3t,
	ptvc=-c(0.21,0.31,0.006,0.053,0.001,0.034,-0.0023))
kalcount(y,preg=-c(7.3,-1),ccov=sex,pinit=0.01,tvc=tvc3ti,
	ptvc=-c(0.2,0.3,0.004,0.055,-0.0015,0.04,0,0),iter=200)

# 0 time origin
kalcount(y,int="Weibull",psh=1,preg=-9)
kalcount(y,preg=-c(8,-1.1),ccov=sex,pinit=0.1,int="Weibull",psh=0.93)
kalcount(y,preg=-c(5.8,-0.87),ccov=sex,pinit=0.04,int="Weibull",psh=1.15,
	tvc=tvc1,ptvc=-c(0.2,0.3))
kalcount(y,preg=-c(7.7,-1),ccov=sex,pinit=0.005,int="Weibull",psh=1,
	tvc=tvc2,ptvc=-c(0.2,0.3,0.005,0.05))
kalcount(y,preg=-c(7.12,-0.97),ccov=sex,pinit=0.008,int="Weibull",psh=1.1,
	tvc=tvc2t,ptvc=-c(0.21,0.3,0.0061,0.053,-0.0032),iter=200)
kalcount(y,preg=-c(7.7,-1),ccov=sex,pinit=0.005,int="Weibull",psh=1,
	tvc=tvc3,ptvc=-c(0.22,0.32,0.005,0.05,0,0.034))
print(zz <- kalcount(y,preg=-c(7.1,-0.96),ccov=sex,pinit=0.01,int="Weibull",
	psh=1.03,tvc=tvc3t,ptvc=-c(0.21,0.3,0.006,0.053,0.0037,0.034,-0.0032)))
kalcount(y,preg=-c(7.7,-1),ccov=sex,pinit=0.01,int="Weibull",psh=1,
	tvc=tvc2is,ptvc=-c(0.2,0.3,0.005,0.05,0,0))

if(interactive()){
postscript("deaths.eps",height=5)
plot.iprofile(zz,nind=1:2,xlab="Months",ylab="Deaths",ylim=c(0,3000),
	lty=c(1,1),pch=c(1,3))
}

kalcount(y,preg=-c(7.1,-0.96),ccov=sex,pinit=0.01,int="gamma",iter=200,
	psh=10,tvc=tvc3t,ptvc=-c(0.21,0.3,0.006,0.053,0.0037,0.034,-0.0032))

# 12 time origin
kalcount(y,int="Weibull",psh=1,preg=1,origin=12)
kalcount(y,preg=-c(8,-1.1),ccov=sex,pinit=0.1,int="Weibull",psh=0.93,
	origin=12)
kalcount(y,preg=-c(5.8,-0.87),ccov=sex,pinit=0.04,int="Weibull",psh=1.15,
	tvc=tvc1,ptvc=-c(0.2,0.3),origin=12)
kalcount(y,preg=-c(8.4,-1.1),ccov=sex,pinit=0.0085,int="Weibull",psh=0.95,
	tvc=tvc2,ptvc=-c(0.23,0.34,0.0066,0.06),origin=12)
kalcount(y,preg=-c(8.4,-1.1),ccov=sex,pinit=0.0085,int="Weibull",psh=0.95,
	tvc=tvc3,ptvc=-c(0.23,0.34,0.0067,0.06,0,0.034),origin=12)
kalcount(y,preg=-c(8.4,-1.1),ccov=sex,pinit=0.0085,int="Weibull",psh=0.95,
	tvc=tvc3t,ptvc=-c(0.23,0.34,0.0067,0.06,0,0.034,-0.001),
	origin=12)

kalcount(y,preg=-c(5.8,-0.87),ccov=sex,pinit=0.04,int="gamma",psh=1.15,
	tvc=tvc1,ptvc=-c(0.2,0.3))
kalcount(y,preg=-c(5.8,-0.87),ccov=sex,pinit=0.04,int="gamma",psh=1.15,
	tvc=tvc2,ptvc=-c(0.2,0.3,0.006,0.05))
#kalcount(y,preg=-c(1,-0.1),ccov=sex,pinit=2,int="log norm",psh=2.7,
#	tvc=tvc1,ptvc=-c(0,0))

kalcount(y,preg=-c(7.3,-1),ccov=sex,pinit=0.1,dep="serial",
	update="Markov",pdep=0.05)
kalcount(y,preg=-c(7.3,-0.9),ccov=sex,pinit=0.01,dep="serial",
	update="kalman",pdep=0.026)
kalcount(y,preg=-c(7.3,-0.9),ccov=sex,pinit=0.01,dep="serial",
	update="count",pdep=0.026)

kalcount(y,preg=-c(7.3,-1),ccov=sex,pinit=0.01,dep="serial",
	update="kalman",pdep=0.01,tvc=tvc1,ptvc=-c(0.32,0.21))
kalcount(y,preg=-c(7.3,-1),ccov=sex,pinit=5,dep="serial",update="count",
	pdep=0.026,tvc=tvc1,ptvc=-c(0.3,0.2))

kalcount(y,preg=-7.3,pinit=5,dep="serial",update="Markov",pdep=0.026)
kalcount(y,preg=-c(7.3,-1),ccov=sex,pinit=5,dep="serial",update="Markov",
	pdep=0.026)
kalcount(y,preg=-c(7.7,-1),ccov=sex,pinit=5,dep="serial",update="Markov",
	pdep=0.026,tvc=tvc1,ptvc=-c(0.3,0.2))
kalcount(y,preg=-c(7.3,-1),ccov=sex,pinit=5,dep="serial",update="Markov",
	pdep=0.026,tvc=tvc2,ptvc=-c(0.3,0.2,0.005,0.05))
kalcount(y,preg=-c(7.3,-1),ccov=sex,pinit=5,dep="serial",update="Markov",
	pdep=0.026,tvc=tvc2t,ptvc=-c(0.3,0.2,0.005,0.05,0),iter=200)
kalcount(y,preg=-c(7.7,-1),ccov=sex,pinit=5,dep="serial",update="Markov",
	pdep=0.026,tvc=tvc3,ptvc=-c(0.22,0.32,0.0045,0.053,0.0023,0.034))
kalcount(y,preg=-c(7.7,-1),ccov=sex,pinit=5,dep="serial",update="Markov",
	pdep=0.026,tvc=tvc3t,
	ptvc=-c(0.21,0.3,0.0058,0.053,0.00077,0.034,-0.003))

# 0 time origin
kalcount(y,preg=-8,pinit=0.3,dep="serial",pdep=0.3,
	update="Markov",int="Weibull",psh=1)
kalcount(y,preg=-c(8,-0.87),ccov=sex,pinit=0.04,dep="serial",pdep=0.026,
	update="Markov",int="Weibull",psh=1.15)
kalcount(y,preg=-c(7.7,-1),ccov=sex,pinit=0.04,dep="serial",pdep=0.026,
	update="Markov",tvc=tvc1,ptvc=-c(0.2,0.3),int="Weibull",psh=1.15)
kalcount(y,preg=-c(7.7,-1),ccov=sex,pinit=0.04,dep="serial",pdep=0.016,
	update="Markov",tvc=tvc2,ptvc=-c(0.22,0.32,0.005,0.05),int="Weibull",
	psh=1)
kalcount(y,preg=-c(7.13,-0.97),ccov=sex,pinit=0.0083,dep="serial",pdep=0.033,
	update="Markov",tvc=tvc2t,ptvc=-c(0.21,0.3,0.005,0.053,-0.0031),
	int="Weibull",psh=1.03,iter=200)
kalcount(y,preg=-c(7.7,-1),ccov=sex,pinit=0.01,dep="serial",pdep=0.02,
	update="Markov",tvc=tvc3,ptvc=-c(0.22,0.32,0.0045,0.053,0.0023,0.034),
	int="Weibull",psh=1)
print(zz <- kalcount(y,preg=-c(7.13,-0.965),ccov=sex,pinit=0.008,dep="serial",
	pdep=0.009,update="Markov",tvc=tvc3t,int="Weibull",psh=1.025,
	ptvc=-c(0.21,0.3,0.0058,0.053,0.00077,0.034,-0.003),iter=200))

# 12 time origin
#kalcount(y,preg=-8.8,pinit=0.13,dep="serial",pdep=0.022,
#	update="Markov",int="Weibull",psh=1,origin=12)
kalcount(y,preg=-c(9.4,-1),ccov=sex,pinit=0.04,dep="serial",pdep=0.026,
	update="Markov",int="Weibull",psh=1,origin=12)
kalcount(y,preg=-c(9.4,-1),ccov=sex,pinit=0.04,dep="serial",pdep=0.026,
	update="Markov",tvc=tvc1,ptvc=-c(0.2,0.3),int="Weibull",psh=0.9,
	origin=12)
kalcount(y,preg=-c(8.4,-1.1),ccov=sex,pinit=0.009,dep="serial",pdep=0.012,
	update="Markov",tvc=tvc2,ptvc=-c(0.23,0.34,0.006,0.06),int="Weibull",
	psh=0.95,origin=12)
kalcount(y,preg=-c(8.41,-1.08),ccov=sex,pinit=0.009,dep="serial",pdep=0.0125,
	update="Markov",tvc=tvc3,ptvc=-c(0.23,0.34,0.006,0.058,0.0019,0.036),
	int="Weibull",psh=0.914,origin=12)
print(zz <- kalcount(y,preg=-c(8.4,-1.1),ccov=sex,pinit=0.0085,dep="serial",
	pdep=0.01,update="Markov",tvc=tvc3t,int="Weibull",psh=0.95,
	ptvc=-c(0.23,0.34,0.0067,0.06,0,0.034,-0.001),origin=12))

if(interactive()){
#postscript("deaths.eps",width=5,height=5)
plot.iprofile(zz,nind=1:2,xlab="Months",ylab="Deaths",ylim=c(0,3000),
	lty=c(1,1),pch=c(1,3))
}
