library(repeated)

y <- scan("dna5.dat",what=character(0),skip=6)
data <- NULL
for(i in 1:length(y))data <- c(data,unlist(strsplit(y[i],split=NULL)))
y <- rbind(c(codes(as.factor(data[1:1046])),rep(1,38)),
	c(codes(as.factor(data[1047:2092])),rep(1,38)),
	codes(as.factor(data[2093:3176])),codes(as.factor(data[3177:4260])))
for(i in 1:4)y[i,] <- ifelse(y[i,]==1,NA,y[i,]-2)

intron <- c(356:472,678:820)
exon <- c(261:355,473:677,821:949)
yexon <- restovec(y[,exon])
yintron <- restovec(y[,intron])

pr <- NULL
for(i in 1:4)pr <- c(pr,sum(as.vector(y[,exon])==i)/1716)
pr
pr <- NULL
for(i in 1:4)pr <- c(pr,sum(as.vector(y[,intron])==i,na.rm=T)/895)
pr

# arrays instead of ~1 below
#mu1b <- function(p) array(rep(p,rep(4,3)),c(4,1,3))
#mu2b <- function(p) array(rep(p,rep(4,6)),c(4,2,3))
#mu3b <- function(p) array(rep(p,rep(4,9)),c(4,3,3))
#mu4b <- function(p) array(rep(p,rep(4,12)),c(4,4,3))
#mu5b <- function(p) array(rep(p,rep(4,15)),c(4,5,3))
#mu6b <- function(p) array(rep(p,rep(4,18)),c(4,6,3))

yyex <- as.numeric(c(t(y[,exon])==1,t(y[,exon])==2,t(y[,exon])==3,
	t(y[,exon])==4))
stateex <- gl(4,1716)
state1ex <- as.factor(c(1,rep(t(y[,exon]-1),4)[1:6863]))
posex <- gl(3,1,6864)
wtex <- rep(1,6864)
wtex[seq(1,6864,by=429)] <- 0
yyin <- as.numeric(c(t(y[,intron])==1,t(y[,intron])==2,t(y[,intron])==3,
	t(y[,intron])==4))
statein <- gl(4,1040)
state1in <- as.factor(c(1,rep(t(y[,intron]-1),4)[1:4159]))
wtin <- rep(1,4160)
wtin[seq(1,4160,by=260)] <- 0

# no difference among triplets
# exons
print(z <- hidden(yexon,dist="mult",pgamma=1,
	cmu=~1,pcmu=rep(1,3),iter=200))
c(1,exp(z$coef[1:3]))/(1+sum(exp(z$coef[1:3])))
print(z <- glm(yyex~stateex*state1ex,family=poisson,weight=wtex))
-sum(yyex*log(z$fit))
-sum(wtex*yyex*log(z$fit))-2*log(sum(wtex[1:1716]*z$fit[1:1716])/1716)
rm(z)

print(z <- hidden(yexon,dist="mult",pgamma=matrix(c(0.6,0.4,0.2,0.8),ncol=2,
	byrow=T),cmu=~1,pcmu=rep(1,6),iter=200))
c(1,exp(z$coef[seq(1,6,by=2)]))/(1+sum(exp(z$coef[seq(1,6,by=2)])))
c(1,exp(z$coef[seq(2,6,by=2)]))/(1+sum(exp(z$coef[seq(2,6,by=2)])))
# better fit than in book
print(z <- hidden(yexon,dist="mult",pgamma=matrix(c(0.1,0.4,0.5,0.3,0.4,
	0.3,0.3,0.2,0.5),ncol=3,byrow=T),cmu=~1,pcmu=rep(1,9),iter=200))
c(1,exp(z$coef[seq(1,9,by=3)]))/(1+sum(exp(z$coef[seq(1,9,by=3)])))
c(1,exp(z$coef[seq(2,9,by=3)]))/(1+sum(exp(z$coef[seq(2,9,by=3)])))
c(1,exp(z$coef[seq(3,9,by=3)]))/(1+sum(exp(z$coef[seq(3,9,by=3)])))
tran <- matrix(0.2,ncol=4,nrow=4)
diag(tran) <- 0.3
tran[1,4] <- tran[2,3] <- tran[3,2] <- tran[4,3] <- 0.3
# better fit than in book
print(z <- hidden(yexon,dist="mult",pgamma=tran,cmu=~1,pcmu=rep(-1,12),
	iter=200))
c(1,exp(z$coef[seq(1,12,by=4)]))/(1+sum(exp(z$coef[seq(1,12,by=4)])))
c(1,exp(z$coef[seq(2,12,by=4)]))/(1+sum(exp(z$coef[seq(2,12,by=4)])))
c(1,exp(z$coef[seq(3,12,by=4)]))/(1+sum(exp(z$coef[seq(3,12,by=4)])))
c(1,exp(z$coef[seq(4,12,by=4)]))/(1+sum(exp(z$coef[seq(4,12,by=4)])))
tran <- matrix(0.2,ncol=5,nrow=5)
diag(tran) <- 0.3
tran[1,2] <- tran[2,3] <- tran[3,2] <- tran[4,2] <- tran[5,2] <- 0.1
# better fit than in book
print(z <- hidden(yexon,dist="mult",pgamma=tran,cmu=~1,pcmu=rep(1,15),
	iter=200))
c(1,exp(z$coef[seq(1,15,by=5)]))/(1+sum(exp(z$coef[seq(1,15,by=5)])))
c(1,exp(z$coef[seq(2,15,by=5)]))/(1+sum(exp(z$coef[seq(2,15,by=5)])))
c(1,exp(z$coef[seq(3,15,by=5)]))/(1+sum(exp(z$coef[seq(3,15,by=5)])))
c(1,exp(z$coef[seq(4,15,by=5)]))/(1+sum(exp(z$coef[seq(4,15,by=5)])))
c(1,exp(z$coef[seq(5,15,by=5)]))/(1+sum(exp(z$coef[seq(5,15,by=5)])))
tran <- matrix(0.1,ncol=6,nrow=6)
diag(tran) <- 0.2
tran[1,4] <- tran[2,3] <- tran[3,2] <- tran[4,3] <- tran[5,1] <- 
	  tran[6,2] <- 0.4
# worse fit than in book
print(z <- hidden(yexon,dist="mult",pgamma=tran,cmu=~1,pcmu=rep(1,18),
	iter=300))
c(1,exp(z$coef[seq(1,18,by=6)]))/(1+sum(exp(z$coef[seq(1,18,by=6)])))
c(1,exp(z$coef[seq(2,18,by=6)]))/(1+sum(exp(z$coef[seq(2,18,by=6)])))
c(1,exp(z$coef[seq(3,18,by=6)]))/(1+sum(exp(z$coef[seq(3,18,by=6)])))
c(1,exp(z$coef[seq(4,18,by=6)]))/(1+sum(exp(z$coef[seq(4,18,by=6)])))
c(1,exp(z$coef[seq(5,18,by=6)]))/(1+sum(exp(z$coef[seq(5,18,by=6)])))
c(1,exp(z$coef[seq(6,18,by=6)]))/(1+sum(exp(z$coef[seq(6,18,by=6)])))

tran <- matrix(c(0,0,0,0,1,0,
	0,0.06,0.6,0,0,0.34,
	0,0,0,0.31,0.69,0,
	0,0.75,0,0,0,0.25,
	0.09,0.69,0,0,0,0.22,
	0.2,0,0.1,0.59,0,0.11),ncol=6,byrow=T)
mu6c <- function(p) array(rep(c(30,-30,-30,-30,p[1:2],-30,p[3:4],30,-30,
	p[5],-30,p[6:7],-30,p[8:9]),rep(4,18)),c(4,6,3))
print(z <- hidden(yexon,dist="mult",pgamma=tran,
	cmu=mu6c,pcmu=rep(0,9),iter=200))
p <- c(30,-30,-30,-30,z$coef[1:2],-30,z$coef[3:4],30,-30,
	z$coef[5],-30,z$coef[6:7],-30,z$coef[8:9])
c(1,exp(p[seq(1,18,by=6)]))/(1+sum(exp(p[seq(1,18,by=6)])))
c(1,exp(p[seq(2,18,by=6)]))/(1+sum(exp(p[seq(2,18,by=6)])))
c(1,exp(p[seq(3,18,by=6)]))/(1+sum(exp(p[seq(3,18,by=6)])))
c(1,exp(p[seq(4,18,by=6)]))/(1+sum(exp(p[seq(4,18,by=6)])))
c(1,exp(p[seq(5,18,by=6)]))/(1+sum(exp(p[seq(5,18,by=6)])))
c(1,exp(p[seq(6,18,by=6)]))/(1+sum(exp(p[seq(6,18,by=6)])))

# different globin type
tran <- matrix(c(0,0,0,0,1,0,
	0,0.06,0.6,0,0,0.34,
	0,0,0,0.31,0.69,0,
	0,0.75,0,0,0,0.25,
	0.09,0.69,0,0,0,0.22,
	0.2,0,0.1,0.59,0,0.11),ncol=6,byrow=T)
mu6aa <- function(p) array(rep(c(30,-30,-30,-30,-30,p[1],-30,p[2:3],30,-30,
	p[4],-30,p[5:6],-30,p[7:8]),rep(2,18)),c(2,6,3))
print(z <- hidden(y[1:2,exon],dist="mult",pgamma=tran,
	cmu=mu6aa,pcmu=rep(0,8),iter=200))
p <- c(30,-30,-30,-30,-30,z$coef[1],-30,z$coef[2:3],30,-30,
	z$coef[4],-30,z$coef[5:6],-30,z$coef[7:8])
c(1,exp(p[seq(1,18,by=6)]))/(1+sum(exp(p[seq(1,18,by=6)])))
c(1,exp(p[seq(2,18,by=6)]))/(1+sum(exp(p[seq(2,18,by=6)])))
c(1,exp(p[seq(3,18,by=6)]))/(1+sum(exp(p[seq(3,18,by=6)])))
c(1,exp(p[seq(4,18,by=6)]))/(1+sum(exp(p[seq(4,18,by=6)])))
c(1,exp(p[seq(5,18,by=6)]))/(1+sum(exp(p[seq(5,18,by=6)])))
c(1,exp(p[seq(6,18,by=6)]))/(1+sum(exp(p[seq(6,18,by=6)])))

tran <- matrix(c(0,0,0,0,1,0,
	0,0,0.67,0,0,0.33,
	0,0,0,0.31,0.69,0,
	0,0.75,0,0,0,0.25,
	0.09,0.69,0,0,0,0.22,
	0.2,0,0.1,0.59,0,0.11),ncol=6,byrow=T)
mu6ab <- function(p) array(rep(c(30,-30,-30,-30,p[1:2],-30,p[3:4],30,-30,
	p[5],-30,p[6:7],-30,p[8:9]),rep(2,18)),c(2,6,3))
print(z <- hidden(y[3:4,exon],dist="mult",pgamma=tran,
	cmu=mu6ab,pcmu=rep(0,9),iter=200))
p <- c(30,-30,-30,-30,z$coef[1:2],-30,z$coef[3:4],30,-30,
	z$coef[5],-30,z$coef[6:7],-30,z$coef[8:9])
c(1,exp(p[seq(1,18,by=6)]))/(1+sum(exp(p[seq(1,18,by=6)])))
c(1,exp(p[seq(2,18,by=6)]))/(1+sum(exp(p[seq(2,18,by=6)])))
c(1,exp(p[seq(3,18,by=6)]))/(1+sum(exp(p[seq(3,18,by=6)])))
c(1,exp(p[seq(4,18,by=6)]))/(1+sum(exp(p[seq(4,18,by=6)])))
c(1,exp(p[seq(5,18,by=6)]))/(1+sum(exp(p[seq(5,18,by=6)])))
c(1,exp(p[seq(6,18,by=6)]))/(1+sum(exp(p[seq(6,18,by=6)])))

# different species and globin type
tran <- matrix(c(0,0,0,0,1,0,
	0,0.06,0.6,0,0,0.34,
	0,0,0,0.31,0.69,0,
	0,0.75,0,0,0,0.25,
	0.09,0.69,0,0,0,0.22,
	0.2,0,0.1,0.59,0,0.11),ncol=6,byrow=T)
mu6a <- function(p) array(rep(c(30,-30,-30,-30,p[1:2],-30,p[3:4],30,-30,
	p[5],-30,p[6:7],-30,p[8:9]),rep(1,18)),c(1,6,3))
print(z <- hidden(y[1,exon,drop=F],dist="mult",pgamma=tran,
	cmu=mu6a,pcmu=rep(0,9),iter=200))
p <- c(30,-30,-30,-30,z$coef[1:2],-30,z$coef[3:4],30,-30,
	z$coef[5],-30,z$coef[6:7],-30,z$coef[8:9])
c(1,exp(p[seq(1,18,by=6)]))/(1+sum(exp(p[seq(1,18,by=6)])))
c(1,exp(p[seq(2,18,by=6)]))/(1+sum(exp(p[seq(2,18,by=6)])))
c(1,exp(p[seq(3,18,by=6)]))/(1+sum(exp(p[seq(3,18,by=6)])))
c(1,exp(p[seq(4,18,by=6)]))/(1+sum(exp(p[seq(4,18,by=6)])))
c(1,exp(p[seq(5,18,by=6)]))/(1+sum(exp(p[seq(5,18,by=6)])))
c(1,exp(p[seq(6,18,by=6)]))/(1+sum(exp(p[seq(6,18,by=6)])))

print(z <- hidden(y[2,exon,drop=F],dist="mult",pgamma=tran,
	cmu=mu6a,pcmu=rep(0,9),iter=200))
p <- c(30,-30,-30,-30,z$coef[1:2],-30,z$coef[3:4],30,-30,
	z$coef[5],-30,z$coef[6:7],-30,z$coef[8:9])
c(1,exp(p[seq(1,18,by=6)]))/(1+sum(exp(p[seq(1,18,by=6)])))
c(1,exp(p[seq(2,18,by=6)]))/(1+sum(exp(p[seq(2,18,by=6)])))
c(1,exp(p[seq(3,18,by=6)]))/(1+sum(exp(p[seq(3,18,by=6)])))
c(1,exp(p[seq(4,18,by=6)]))/(1+sum(exp(p[seq(4,18,by=6)])))
c(1,exp(p[seq(5,18,by=6)]))/(1+sum(exp(p[seq(5,18,by=6)])))
c(1,exp(p[seq(6,18,by=6)]))/(1+sum(exp(p[seq(6,18,by=6)])))

print(z <- hidden(y[3,exon,drop=F],dist="mult",pgamma=tran,
	cmu=mu6a,pcmu=rep(0,9),iter=200))
p <- c(30,-30,-30,-30,z$coef[1:2],-30,z$coef[3:4],30,-30,
	z$coef[5],-30,z$coef[6:7],-30,z$coef[8:9])
c(1,exp(p[seq(1,18,by=6)]))/(1+sum(exp(p[seq(1,18,by=6)])))
c(1,exp(p[seq(2,18,by=6)]))/(1+sum(exp(p[seq(2,18,by=6)])))
c(1,exp(p[seq(3,18,by=6)]))/(1+sum(exp(p[seq(3,18,by=6)])))
c(1,exp(p[seq(4,18,by=6)]))/(1+sum(exp(p[seq(4,18,by=6)])))
c(1,exp(p[seq(5,18,by=6)]))/(1+sum(exp(p[seq(5,18,by=6)])))
c(1,exp(p[seq(6,18,by=6)]))/(1+sum(exp(p[seq(6,18,by=6)])))

print(z <- hidden(y[4,exon,drop=F],dist="mult",pgamma=tran,
	cmu=mu6a,pcmu=rep(0,9),iter=200))
p <- c(30,-30,-30,-30,z$coef[1:2],-30,z$coef[3:4],30,-30,
	z$coef[5],-30,z$coef[6:7],-30,z$coef[8:9])
c(1,exp(p[seq(1,18,by=6)]))/(1+sum(exp(p[seq(1,18,by=6)])))
c(1,exp(p[seq(2,18,by=6)]))/(1+sum(exp(p[seq(2,18,by=6)])))
c(1,exp(p[seq(3,18,by=6)]))/(1+sum(exp(p[seq(3,18,by=6)])))
c(1,exp(p[seq(4,18,by=6)]))/(1+sum(exp(p[seq(4,18,by=6)])))
c(1,exp(p[seq(5,18,by=6)]))/(1+sum(exp(p[seq(5,18,by=6)])))
c(1,exp(p[seq(6,18,by=6)]))/(1+sum(exp(p[seq(6,18,by=6)])))

# introns
print(z <- hidden(yintron,dist="mult",pgamma=1,cmu=~1,pcmu=rep(1,3),
	iter=200))
c(1,exp(z$coef[1:3]))/(1+sum(exp(z$coef[1:3])))
print(z <- glm(yyin~statein*state1in,family=poisson,weight=wtin))
-sum(yyin[!is.na(yyin)&!is.na(state1in)]*log(z$fit))
-sum(wtin[!is.na(yyin)&!is.na(state1in)]*yyin[!is.na(yyin)&!is.na(state1in)]*
	log(z$fit))-2*log(sum(wtin[2081:3120]*z$fit[2081:3120])/1040)
rm(z)

print(z <- hidden(yintron,dist="mult",
	pgamma=matrix(c(0.6,0.4,0.2,0.8),ncol=2,byrow=T),
	cmu=~1,pcmu=rep(1,6),iter=200))
c(1,exp(z$coef[seq(1,6,by=2)]))/(1+sum(exp(z$coef[seq(1,6,by=2)])))
c(1,exp(z$coef[seq(2,6,by=2)]))/(1+sum(exp(z$coef[seq(2,6,by=2)])))

print(z <- hidden(yintron,dist="mult",pgamma=matrix(c(0.1,0.4,0.5,0.3,0.4,
	0.3,0.3,0.2,0.5),ncol=3,byrow=T),cmu=~1,pcmu=rep(1,9),iter=200))
c(1,exp(z$coef[seq(1,9,by=3)]))/(1+sum(exp(z$coef[seq(1,9,by=3)])))
c(1,exp(z$coef[seq(2,9,by=3)]))/(1+sum(exp(z$coef[seq(2,9,by=3)])))
c(1,exp(z$coef[seq(3,9,by=3)]))/(1+sum(exp(z$coef[seq(3,9,by=3)])))
tran <- matrix(0.2,ncol=4,nrow=4)
diag(tran) <- 0.3
tran[1,4] <- tran[2,3] <- tran[3,2] <- tran[4,3] <- 0.3
print(z <- hidden(yintron,dist="mult",pgamma=tran,cmu=~1,pcmu=rep(1,12),
	iter=200))
c(1,exp(z$coef[seq(1,12,by=4)]))/(1+sum(exp(z$coef[seq(1,12,by=4)])))
c(1,exp(z$coef[seq(2,12,by=4)]))/(1+sum(exp(z$coef[seq(2,12,by=4)])))
c(1,exp(z$coef[seq(3,12,by=4)]))/(1+sum(exp(z$coef[seq(3,12,by=4)])))
c(1,exp(z$coef[seq(4,12,by=4)]))/(1+sum(exp(z$coef[seq(4,12,by=4)])))
tran <- matrix(0.2,ncol=5,nrow=5)
diag(tran) <- 0.3
tran[1,2] <- tran[2,3] <- tran[3,2] <- tran[4,2] <- tran[5,2] <- 0.1
print(z <- hidden(yintron,dist="mult",pgamma=tran,
	cmu=~1,pcmu=rep(-1,15),iter=200))
c(1,exp(z$coef[seq(1,15,by=5)]))/(1+sum(exp(z$coef[seq(1,15,by=5)])))
c(1,exp(z$coef[seq(2,15,by=5)]))/(1+sum(exp(z$coef[seq(2,15,by=5)])))
c(1,exp(z$coef[seq(3,15,by=5)]))/(1+sum(exp(z$coef[seq(3,15,by=5)])))
c(1,exp(z$coef[seq(4,15,by=5)]))/(1+sum(exp(z$coef[seq(4,15,by=5)])))
c(1,exp(z$coef[seq(5,15,by=5)]))/(1+sum(exp(z$coef[seq(5,15,by=5)])))
tran <- matrix(0.15,ncol=6,nrow=6)
diag(tran) <- 0.25
tran[1,1] <- 0.2
tran[1,2] <- 0.2
print(z <- hidden(yintron,dist="mult",pgamma=tran,
	cmu=~1,pcmu=rep(-1,18),iter=200))
c(1,exp(z$coef[seq(1,18,by=6)]))/(1+sum(exp(z$coef[seq(1,18,by=6)])))
c(1,exp(z$coef[seq(2,18,by=6)]))/(1+sum(exp(z$coef[seq(2,18,by=6)])))
c(1,exp(z$coef[seq(3,18,by=6)]))/(1+sum(exp(z$coef[seq(3,18,by=6)])))
c(1,exp(z$coef[seq(4,18,by=6)]))/(1+sum(exp(z$coef[seq(4,18,by=6)])))
c(1,exp(z$coef[seq(5,18,by=6)]))/(1+sum(exp(z$coef[seq(5,18,by=6)])))
c(1,exp(z$coef[seq(6,18,by=6)]))/(1+sum(exp(z$coef[seq(6,18,by=6)])))

# by triplets
pr <- NULL
for(i in 1:3){
	pr1 <- NULL
	for(j in 1:4)pr1 <- c(pr1,sum(as.vector(y[,exon])[seq(i,1716,by=3)]==j)/572)
	pr <- rbind(pr,pr1)}
pr

# list of functions
mu4tvc <- list(function(p)rep(c(p[1:2],-30),143),
	function(p)rep(p[3:5],143),
	function(p)rep(c(p[6],-30,-30),143),
	function(p)rep(c(-30,-30,-30),143),
	function(p)rep(p[7:9],143),
	function(p)rep(p[10:12],143),
	function(p)rep(c(-30,-30,-30),143),
	function(p)rep(c(p[13],-30,p[14]),143),
	function(p)rep(c(p[15],-30,p[16]),143),
	function(p)rep(p[17:19],143),
	function(p)rep(c(p[20:21],30),143),
	function(p)rep(c(p[22],-30,p[23]),143))
# equivalent function returning an array
#mu4tvc <- function(p) array(c(rep(c(p[1:2],-30),143),
#	rep(p[3:5],143),
#	rep(c(p[6],-30,-30),143),
#	rep(c(-30,-30,-30),143),
#	rep(p[7:9],143),
#	rep(p[10:12],143),
#	rep(c(-30,-30,-30),143),
#	rep(c(p[13],-30,p[14]),143),
#	rep(c(p[15],-30,p[16]),143),
#	rep(p[17:19],143),
#	rep(c(p[20:21],30),143),
#	rep(c(p[22],-30,p[23]),143)),c(429,4,3))
tran <- matrix(c(0.67,0,0,0.33,
	0.25,0.75,0,0,
	0.12,0.62,0.26,0,
	0,0,1,0),ncol=4,byrow=T)
print(z <- hidden(yexon,dist="mult",pgamma=tran,
	tvmu=mu4tvc,ptvmu=rep(0,23),iter=200))
p <- c(z$coef[1:2],-30,z$coef[3:6],-30,-30,-30,-30,-30,z$coef[7:12],
	-30,-30,-30,z$coef[13],-30,z$coef[14:15],-30,z$coef[16:21],30,
	z$coef[22],-30,z$coef[23])
c(1,exp(p[seq(1,36,by=12)]))/(1+sum(exp(p[seq(1,36,by=12)])))
c(1,exp(p[seq(4,36,by=12)]))/(1+sum(exp(p[seq(4,36,by=12)])))
c(1,exp(p[seq(7,36,by=12)]))/(1+sum(exp(p[seq(7,36,by=12)])))
c(1,exp(p[seq(10,36,by=12)]))/(1+sum(exp(p[seq(10,36,by=12)])))

c(1,exp(p[seq(2,36,by=12)]))/(1+sum(exp(p[seq(2,36,by=12)])))
c(1,exp(p[seq(5,36,by=12)]))/(1+sum(exp(p[seq(5,36,by=12)])))
c(1,exp(p[seq(8,36,by=12)]))/(1+sum(exp(p[seq(8,36,by=12)])))
c(1,exp(p[seq(11,36,by=12)]))/(1+sum(exp(p[seq(11,36,by=12)])))

c(1,exp(p[seq(3,36,by=12)]))/(1+sum(exp(p[seq(3,36,by=12)])))
c(1,exp(p[seq(6,36,by=12)]))/(1+sum(exp(p[seq(6,36,by=12)])))
c(1,exp(p[seq(9,36,by=12)]))/(1+sum(exp(p[seq(9,36,by=12)])))
c(1,exp(p[seq(12,36,by=12)]))/(1+sum(exp(p[seq(12,36,by=12)])))
if(interactive()){
postscript("dna5.eps",width=5,height=7)
par(font.main=1,mar=c(3.5,3.5,3,1),mgp=c(2.5,1,0))
plot(z,nind=c(1,3),main=c(expression(alpha[1]-globin),
	expression(theta[1]-globin)),xlab="Codon number")
dev.off()
}

# different globin type
tran <- matrix(c(0.41,0,0,0.59,
	0.25,0.75,0,0,
	0.12,0.62,0.26,0,
	0,0,1,0),ncol=4,byrow=T)
print(z <- hidden(y[1:2,exon],dist="mult",pgamma=tran,
	tvmu=mu4tvc,ptvmu=rep(0,23),iter=200))
p <- c(z$coef[1:2],-30,z$coef[3:6],-30,-30,-30,-30,-30,z$coef[7:12],
	-30,-30,-30,z$coef[13],-30,z$coef[14:15],-30,z$coef[16:21],30,
	z$coef[22],-30,z$coef[23])
c(1,exp(p[seq(1,36,by=12)]))/(1+sum(exp(p[seq(1,36,by=12)])))
c(1,exp(p[seq(4,36,by=12)]))/(1+sum(exp(p[seq(4,36,by=12)])))
c(1,exp(p[seq(7,36,by=12)]))/(1+sum(exp(p[seq(7,36,by=12)])))
c(1,exp(p[seq(10,36,by=12)]))/(1+sum(exp(p[seq(10,36,by=12)])))

c(1,exp(p[seq(2,36,by=12)]))/(1+sum(exp(p[seq(2,36,by=12)])))
c(1,exp(p[seq(5,36,by=12)]))/(1+sum(exp(p[seq(5,36,by=12)])))
c(1,exp(p[seq(8,36,by=12)]))/(1+sum(exp(p[seq(8,36,by=12)])))
c(1,exp(p[seq(11,36,by=12)]))/(1+sum(exp(p[seq(11,36,by=12)])))

c(1,exp(p[seq(3,36,by=12)]))/(1+sum(exp(p[seq(3,36,by=12)])))
c(1,exp(p[seq(6,36,by=12)]))/(1+sum(exp(p[seq(6,36,by=12)])))
c(1,exp(p[seq(9,36,by=12)]))/(1+sum(exp(p[seq(9,36,by=12)])))
c(1,exp(p[seq(12,36,by=12)]))/(1+sum(exp(p[seq(12,36,by=12)])))
print(z <- hidden(y[3:4,exon],dist="mult",pgamma=tran,
	tvmu=mu4tvc,ptvmu=rep(0,23),iter=200))
p <- c(z$coef[1:2],-30,z$coef[3:6],-30,-30,-30,-30,-30,z$coef[7:12],
	-30,-30,-30,z$coef[13],-30,z$coef[14:15],-30,z$coef[16:21],30,
	z$coef[22],-30,z$coef[23])
c(1,exp(p[seq(1,36,by=12)]))/(1+sum(exp(p[seq(1,36,by=12)])))
c(1,exp(p[seq(4,36,by=12)]))/(1+sum(exp(p[seq(4,36,by=12)])))
c(1,exp(p[seq(7,36,by=12)]))/(1+sum(exp(p[seq(7,36,by=12)])))
c(1,exp(p[seq(10,36,by=12)]))/(1+sum(exp(p[seq(10,36,by=12)])))

c(1,exp(p[seq(2,36,by=12)]))/(1+sum(exp(p[seq(2,36,by=12)])))
c(1,exp(p[seq(5,36,by=12)]))/(1+sum(exp(p[seq(5,36,by=12)])))
c(1,exp(p[seq(8,36,by=12)]))/(1+sum(exp(p[seq(8,36,by=12)])))
c(1,exp(p[seq(11,36,by=12)]))/(1+sum(exp(p[seq(11,36,by=12)])))

c(1,exp(p[seq(3,36,by=12)]))/(1+sum(exp(p[seq(3,36,by=12)])))
c(1,exp(p[seq(6,36,by=12)]))/(1+sum(exp(p[seq(6,36,by=12)])))
c(1,exp(p[seq(9,36,by=12)]))/(1+sum(exp(p[seq(9,36,by=12)])))
c(1,exp(p[seq(12,36,by=12)]))/(1+sum(exp(p[seq(12,36,by=12)])))

# different species and globin type
print(z <- hidden(y[1,exon,drop=F],dist="mult",pgamma=tran,
	tvmu=mu4tvc,ptvmu=rep(0,23),iter=200))
print(z <- hidden(y[2,exon,drop=F],dist="mult",pgamma=tran,
	tvmu=mu4tvc,ptvmu=rep(0,23),iter=200))
print(z <- hidden(y[3,exon,drop=F],dist="mult",pgamma=tran,
	tvmu=mu4tvc,ptvmu=rep(0,23),iter=200))
print(z <- hidden(y[4,exon,drop=F],dist="mult",pgamma=tran,
	tvmu=mu4tvc,ptvmu=rep(0,23),iter=200))
