library(repeated)
library(event)

freq <- scan("horse.dat",skip=3)
y <- matrix(freq,ncol=20,byrow=T)
corp <- gl(14,20,280)
corp4 <- (corp==1)|(corp==2)|(corp==7)|(corp==12)
c4 <- c(1,1,0,0,0,0,1,0,0,0,0,1,0,0)
year <- gl(20,1,280)
year2 <- as.numeric(year)>3
lyear <- as.numeric(year)
pw <- year!=1

if(interactive()){
postscript("horse.eps",height=5)
par(mfrow=c(1,2),font.main=1)
cprocess(events=y[c(1,2,7,12),],lty=rep(1,14),xlab="Year",
	ylab="Total deaths",main="Special corps",ylim=c(0,25))
cprocess(events=y[c(3,4,5,6,8,9,10,11,13,14),],lty=rep(1,14),
	xlab="Year",ylab="",main="Other corps",ylim=c(0,25))
}
y <- restovec(y)

sum(freq[freq>0]-freq[freq>0]*log(freq[freq>0])+lgamma(freq[freq>0]+1))+280
print(z0 <- glm(freq~1,family=poisson))
z0$aic/2
print(z1 <- update(z0,.~.+corp))
z1$aic/2
print(z2 <- update(z0,.~.+corp4))
z2$aic/2
print(z3 <- update(z2,.~.+year))
z3$aic/2
print(z4 <- update(z2,.~.+year2))
z4$aic/2
print(z5 <- update(z2,.~.+lyear))
z5$aic/2
print(z6 <- update(z4,weights=pw))
z6$aic/2+14
print(z6 <- glm(freq[2:280]~corp4[2:280]+year2[2:280]+freq[1:279],
	family=poisson,weights=pw[2:280]))
z6$aic/2

exp(z4$coef[1]+z4$coef[2])
exp(-z4$coef[2])
exp(z4$coef[3])

kalcount(y,preg=0.25,pinit=0.6)

kalcount(y,preg=0.25,pinit=0.6,pdep=0.5,dep="serial",update="Markov")
kalcount(y,preg=0.25,pinit=0.6,pdep=0.5,dep="serial",update="event")
kalcount(y,preg=0.25,pinit=0.6,pdep=0.5,dep="serial",update="count")
kalcount(y,preg=c(0.5,0),pinit=0.6,pdep=0.5,dep="serial",update="count",
	ccov=c4)
kalcount(y,preg=0.25,pinit=0.6,dep="frailty")
