library(event)

rain <- scan("rain.dat",skip=3)
year <- gl(11,30,330)
day <- gl(30,1,330)
wt <- as.numeric(day)>1

if(interactive()){
postscript("rain.eps",height=5,width=5)
par(mar=c(3.5,3.5,3,1),mgp=c(2.5,1,0))
cprocess(events=matrix(rain,ncol=30,byrow=T),lty=rep(1,11),ylim=c(0,15),
	xlab="Day",ylab="Total rainy days")
dev.off()
}

summary(z0 <- glm(rain~1,family=binomial,weights=wt))
z0$aic/2
# unconditional probability of rain
exp(z0$coef)/(1+exp(z0$coef))
summary(z1 <- glm(rain[2:330]~rain[1:329],family=binomial,weights=wt[2:330]))
z1$aic/2
a <- exp(sum(z1$coef))
# probability of rain, given rain the previous day
a/(1+a)
# probability of rain, given dry the previous day
exp(z1$coef[1])/(1+exp(z1$coef[1]))
summary(z2 <- glm(rain[2:330]~rain[1:329]+year[2:330],family=binomial,
	weights=wt[2:330]))
z2$aic/2
