options(contrasts = c("contr.sum", "contr.poly"))
freq <- scan("sweden.dat",skip=7)
v70 <- gl(4,1,64)
v68 <- gl(4,4,64)
v64 <- gl(4,16,64)

tapply(freq,list(v64,v68),sum)
tapply(freq,list(v68,v70),sum)

print(z0 <- glm(freq~v64*v68+v68*v70,family=poisson))
z0$aic/2
print(zs <- glm(freq~v64*v68*v70,family=poisson))
zs$aic/2

sym1 <- as.factor((((v64==2)&(v68==1))|((v68==2)&(v64==1)))+
	(((v64==3)&(v68==1))|((v68==3)&(v64==1)))*2+
	(((v64==4)&(v68==1))|((v68==4)&(v64==1)))*3+
	(((v64==3)&(v68==2))|((v68==3)&(v64==2)))*4+
	(((v64==4)&(v68==2))|((v68==4)&(v64==2)))*5+
	(((v64==4)&(v68==3))|((v68==4)&(v64==3)))*6)
sym2 <- as.factor((((v70==2)&(v68==1))|((v68==2)&(v70==1)))+
	(((v70==3)&(v68==1))|((v68==3)&(v70==1)))*2+
	(((v70==4)&(v68==1))|((v68==4)&(v70==1)))*3+
	(((v70==3)&(v68==2))|((v68==3)&(v70==2)))*4+
	(((v70==4)&(v68==2))|((v68==4)&(v70==2)))*5+
	(((v70==4)&(v68==3))|((v68==4)&(v70==3)))*6)

pw1 <- (v70!=v68)&(v68!=v64)
print(z1 <- glm(freq~sym1+sym2+v64+v68+v70,family=poisson,weights=pw1))
z1$aic/2+sum(!pw1)
print(z2 <- update(z1,.~.-v64-v68-v70))
z2$aic/2+sum(!pw1)
-sum(z1$coef[2:6])
-sum(z1$coef[7:11])

# other transition unstructured
print(z3 <- glm(freq~sym1+v64+v68*v70,family=poisson,weights=pw1))
z3$aic/2+sum(!pw1)
print(z4 <- glm(freq~sym2+v64*v68+v70,family=poisson,weights=pw1))
z4$aic/2+sum(!pw1)

# other transition independent
print(z5 <- glm(freq~sym1+v64+v68+v70,family=poisson,weights=pw1))
z5$aic/2+sum(!pw1)
print(z6 <- glm(freq~sym2+v64+v68+v70,family=poisson,weights=pw1))
z6$aic/2+sum(!pw1)

# mover-stayer
print(z7 <- glm(freq~v64+v68+v70,family=poisson,weights=pw1))
z7$aic/2+sum(!pw1)

rw1 <- as.factor((as.numeric(v64)>as.numeric(v68))*
	(as.numeric(v64)-as.numeric(v68))+(as.numeric(v68)>as.numeric(v64))*
	(as.numeric(v68)-as.numeric(v64))+1)
rw2 <- as.factor((as.numeric(v70)>as.numeric(v68))*
	(as.numeric(v70)-as.numeric(v68))+(as.numeric(v68)>as.numeric(v70))*
	(as.numeric(v68)-as.numeric(v70))+1)
arw1 <- as.factor((as.numeric(v64)>as.numeric(v68))*
	(as.numeric(v64)-as.numeric(v68))+(as.numeric(v68)>as.numeric(v64))*
	((as.numeric(v68)-as.numeric(v64))+3)+1)
arw2 <- as.factor((as.numeric(v70)>as.numeric(v68))*
	(as.numeric(v70)-as.numeric(v68))+(as.numeric(v68)>as.numeric(v70))*
	((as.numeric(v68)-as.numeric(v70))+3)+1)
print(z8 <- glm(freq~rw1+rw2+v64+v68+v70,family=poisson,weights=pw1))
z8$aic/2+sum(!pw1)
print(z9 <- glm(freq~arw1+arw2+v64+v68+v70,family=poisson,weights=pw1))
z9$aic/2+sum(!pw1)
